package com.dsic.gj_erp.bean.sy;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import com.dsic.gj_erp.annotation.Dict;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * <p>
 * 系统日志表
 * </p>
 *
 * @author xhj
 * @since 2021-04-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="SyLog对象", description="系统日志表")
public class SyLog extends Model<SyLog> {

    private static final long serialVersionUID=1L;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    @ApiModelProperty(value = "职号")
    private String userCode;

    @ApiModelProperty(value = "姓名")
    private String userName;

    @Dict(dictTable ="sy_system",dictText = "system_name",dictCode = "system_code")
    @ApiModelProperty(value = "子系统编码")
    private String systemCode;

    @ApiModelProperty(value = "子系统名称")
    private String systemName;

    @ApiModelProperty(value = "使用内容:模块>子模块>菜单名称")
    private String content;

    @ApiModelProperty(value = "方法")
    private String method;

    @ApiModelProperty(value = "计算机名")
    private String computerName;

    private String ip;

    @ApiModelProperty(value = "使用日期时间")
    private String createTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
