package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.pgd.DmPpxxb;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.pgd.DmPpxxbService;
import lombok.AllArgsConstructor;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-12-14
 */
@RestController
@RequestMapping("/dmPpxxb")
@AllArgsConstructor
public class DmPpxxbController {

    private final DmQfxqService qfxqService;
    private final DmPpxxbService ppxxbService;

    @PostMapping("getDmppxxbList")
    public ResultBean<?> getDmppxxbList(@RequestBody DmPpxxb dmPpxxb){
        List<DmPpxxb> list = ppxxbService.list(Wrappers.<DmPpxxb>lambdaQuery()
                .eq(DmPpxxb::getDcCh, dmPpxxb.getDcCh())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDwh()),DmPpxxb::getDwh, dmPpxxb.getDwh())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getQy()),DmPpxxb::getQy, dmPpxxb.getQy())
        );
        return new ResultBean<>(list);
    }

    @PostMapping("saveDmppxxb")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> save(@RequestBody List<DmPpxxb> list){
        list.forEach(item->item.setZt("00"));
        ppxxbService.saveOrUpdateBatchByMultiId(list);

        return new ResultBean<>();
    }

}

