package com.dsic.gj_erp.mapper;

import org.mapstruct.Mapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
@Mapper
public interface SyuserMapper {

    List<Map> getUserMenu(String usercode, String systemcode);

    //------------------------------------------------------
    List<Map> getDepartList();

    List<Map> getRoleList();

    Integer addRole(Map role);

    Integer deleteRole(String role_code);

    Integer updateRole(Map role);

    List<Map> getRoleListByUser(String user_code);

    Integer addRoleForUser(Map<String, Object> user_role);

    Integer deleteRoleForUser(Map<String, Object> user_role);

    List<Map> getSystemList();

    List<Map> getMenuList();

    List<Map> getUserListByMenu(int menu_id);

    List<Map> getInstitutionList();

    List<Map> getUserListByRole(String role_code);

    List<Map> getInstitutionListByRole(String role_code);

    List<Map> getSystemListByRole(String role_code);

    Integer addRoleForInstitution(Map<String, Object> institution_role);

    Integer deleteRoleForInstitution(Map<String, Object> institution_role);

    Integer addRoleForSystem(Map<String, Object> system_role);

    Integer deleteRoleForSystem(Map<String, Object> system_role);


    List<Map> getMenuListByRole(String role_code);

    void addRoleForMenu(Map<String, Object> menu_role);

    void deleteRoleForMenu(Map<String, Object> menu_role);

    void addFingerprintResult(String uuid, String fingerprint, String user_code);

    String getCodeByUuid(String uuid);

    Integer updateFingerprint(String uuid, String fingerprint);
    Integer updateFingerprint1(String userCode, String fingerprint);
    Integer updateFingerprint2(String userCode, String fingerprint);
    Integer updateFingerprint3(String userCode, String fingerprint);

    Map<String,Object> getUserInfo(Map<String,Object> map);
}
