package com.dsic.gj_erp.service.jcsj.impl;


import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmSbrydyp;
import com.dsic.gj_erp.dao.jcsj.EmSbrydypRepository;
import com.dsic.gj_erp.mapper.jcsj.EmSbrydypMapper;
import com.dsic.gj_erp.service.jcsj.EmSbrydypService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class EmSbrydypServiceImpl extends ServiceImpl<EmSbrydypMapper, EmSbrydyp> implements EmSbrydypService {
    @Resource
    EmSbrydypMapper emSbrydypMapper;
    @Resource
    EmSbrydypRepository emSbrydypRepository;

    @Override
        public List<EmSbrydyp> getList(JSONObject json) {
        QueryWrapper<EmSbrydyp> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("sbmc"))){
            queryWrapper.eq("SBMC",json.getString("sbmc"));
        }
        List<EmSbrydyp> emSbjbbs=emSbrydypMapper.selectList(queryWrapper);
        return emSbjbbs;
    }

    @Override
    public void save(List<EmSbrydyp> emSbrydyps, HttpServletRequest request) {
        String yhms=(String) request.getAttribute("yhms");
        emSbrydyps.forEach(emSbrydyp -> {
            if (StringUtils.isNotEmpty(emSbrydyp.getSbbh())&&StringUtils.isNotEmpty(emSbrydyp.getRymc())){
                emSbrydyp.setRymc(yhms);
                //emSbrydypMapper.insert(emSbrydyp);
            }
        });
        saveBatch(emSbrydyps);
    }

    @Override
    public void update(List<EmSbrydyp> emSbcnps) {
        updateBatchById(emSbcnps);
    }

    @Override
    public void delete(List<EmSbrydyp> emSbcnps) {
      //  List<String> idList=emSbcnps.stream().map(EmSbrydyp::getSbbh).collect(Collectors.toList());
      //  emSbrydypRepository.deleteAll(emSbcnps);
        QueryWrapper<EmSbrydyp> emSbrydypQueryWrapper=new QueryWrapper<>();
        for (EmSbrydyp emSbrydyp:emSbcnps) {
            emSbrydypQueryWrapper.eq("SBBH",emSbrydyp.getSbbh());
            emSbrydypQueryWrapper.eq("RYMC",emSbrydyp.getRymc());
            emSbrydypQueryWrapper.or();
        }
        emSbrydypMapper.delete(emSbrydypQueryWrapper);
    }

    @Override
    public List<Map> getRYList() {
        List<Map> mapList=emSbrydypRepository.getRYList();
        return mapList;
    }
}
