package com.dsic.gj_erp.service.sy.impl;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.sy.SyDict;
import com.dsic.gj_erp.bean.tree.ProjectTreeVo;
import com.dsic.gj_erp.mapper.SyDictMapper;
import com.dsic.gj_erp.service.sy.SyDictService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.apache.commons.lang3.StringUtils;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xhj
 * @since 2021-03-15
 */
@Service
public class SyDictServiceImpl extends ServiceImpl<SyDictMapper, SyDict> implements SyDictService {


    @Override
    public List<ProjectTreeVo> getTreeList(Map<String, Object> params) {
        QueryWrapper<SyDict> queryWrapper = new QueryWrapper<SyDict>();
        if (!StringUtils.isBlank((String)params.get("name"))){
            queryWrapper.and(wp->wp.like("dict_code",params.get("name")).or().like("dict_name",params.get("name")));
        }
        List<SyDict> list = this.list(queryWrapper);
        //父级
        List<ProjectTreeVo> vo= new ArrayList<>();
        ProjectTreeVo projectTreeVo =new ProjectTreeVo();
        //子级
        List<ProjectTreeVo> projectTreeVoList = new ArrayList<>();

        list.stream().forEach(e->{
            ProjectTreeVo tree=new ProjectTreeVo();
            tree.setId(e.getDictCode());
            tree.setLabel(e.getDictName());
            tree.setParentBm("@@@");
            projectTreeVoList.add(tree);
        });
        projectTreeVo.setId("@@@").setLabel("编码类别").setChildren(projectTreeVoList);
        vo.add(projectTreeVo);
        return  vo;


    }

    @Override
    public List<ProjectTreeVo> getTxTreeList(Map<String, Object> params) {
        QueryWrapper<SyDict> queryWrapper = new QueryWrapper<SyDict>();

        queryWrapper.eq(StringUtils.isNotBlank((String)params.get("code")),"system_code",params.get("code"));
        if(StringUtils.isNotBlank((String)params.get("name"))){
            queryWrapper.and(wp->wp.like("dict_code",params.get("name")).or().like("dict_name",params.get("name")));
        }
        List<SyDict> list = this.list(queryWrapper);
        //父级
        List<ProjectTreeVo> vo= new ArrayList<>();
        ProjectTreeVo projectTreeVo =new ProjectTreeVo();
        //子级
        List<ProjectTreeVo> projectTreeVoList = new ArrayList<>();

        list.stream().forEach(e->{
            ProjectTreeVo tree=new ProjectTreeVo();
            tree.setId(e.getDictCode());
            tree.setLabel(e.getDictName()+"["+e.getDictCode()+"]");
            tree.setParentBm("@@@");
            projectTreeVoList.add(tree);
        });
        projectTreeVo.setId("@@@").setLabel("编码类别").setChildren(projectTreeVoList);
        vo.add(projectTreeVo);
        return  vo;
    }

    @Override
    public List<ProjectTreeVo> getTreeListForQKFL(Map<String, Object> params) {
        QueryWrapper<SyDict> queryWrapper = new QueryWrapper<SyDict>();

        queryWrapper.eq(StringUtils.isNotBlank((String)params.get("code")),"system_code",params.get("code"))
                    .in("dict_name","集团切块","舾装切块");

        if(StringUtils.isNotBlank((String)params.get("name"))){
            queryWrapper.and(wp->wp.like("dict_code",params.get("name")).or().like("dict_name",params.get("name")));
        }
        List<SyDict> list = this.list(queryWrapper);
        //父级
        List<ProjectTreeVo> vo= new ArrayList<>();
        ProjectTreeVo projectTreeVo =new ProjectTreeVo();
        //子级
        List<ProjectTreeVo> projectTreeVoList = new ArrayList<>();

        list.stream().forEach(e->{
            ProjectTreeVo tree=new ProjectTreeVo();
            tree.setId(e.getDictCode());
            tree.setLabel(e.getDictName());
            tree.setParentBm("@@@");
            projectTreeVoList.add(tree);
        });
        projectTreeVo.setId("@@@").setLabel("编码类别").setChildren(projectTreeVoList);
        vo.add(projectTreeVo);
        return  vo;
    }
}
